module WeatherModel
  module Storer
    class Mysql < ActiveRecord::Base
      @@source = self.name[0..-8]

      @@settings = Source::Schema.const_get(self.name[0..-8])
      
      self.table_name = @@settings[:table_name]
    end

    class Ohm < Ohm::Model
      require "ohm/expire"
      include Ohm::Expire
      TTL = 5

      attribute Schema.keys
      [:index, :unique].each do |x|
        method(x).call Schema::Setting[x]
      end
      
      expire TTL
      
    private
      def son his_son # input like :Post
        # collection :posts, :Post
        collection(his_son.to_s.underscore.pluralize.to_sym, his_son) if SourceSchema.const_defined?(his_son)
      end

      def dad his_dad # input like :Post
        # reference :post, :Post
        reference(his_dad.to_s.underscore.to_sym, his_dad )if his_dad SourceSchema.const_defined?(his_son)
      end
    end      
  end
end
